use strict;
use warnings;
use POSIX;

#print sprintf("%x %x", characterizeish(0x10FFFF)), "\n";
#my @range = @_;
#for my $a (0xdb80..0xdbff) {
#	for my $b (0xdb80..0xdbff) {
#		my $d = numberizeish($a, $b);
#		print sprintf("%x %x %x %x %x", $a, $b, $d, characterizeish($d)), "\n";
#	}
#}

#range(0xdb80,0xdbff);
#range(0xd800,0xdfff);
print sprintf("%x", numberizeish(0xD83D, 0xDE00)), "\n";
print sprintf("%x", numberizeish(0xD83E, 0xDA00)), "\n";

sub range {
	my @range = @_;
	for my $a ($range[0]..$range[1]) {
		for my $b ($range[0]..$range[1]) {
			my $d = numberizeish($a, $b);
			my ($e, $f) = characterizeish($d);
			if (($e != $a) || ($f != $b)) {
				print 'bad ';
			}
			print sprintf("%x %x %x %x %x", $a, $b, $d, $e, $f), "\n";
		}
	}
}

sub numberizeish {
	my @character = @_;
	my $onend;
	if (@character > 1) {
		$onend = ($character[0] - 0xD800) * 0x400 + $character[1] - 0xDC00 + 0x10000;
	} else {
		$onend = $character[0];
	}
	return $onend;
}

sub characterizeish {
	my $smilly = shift;
	my @charpoints;
	if ($smilly > 0xFFFF) {
		$smilly -= 0x10000;
		push @charpoints, 0xD800 + ($smilly >> 10), 0xDC00 + ($smilly & 0x3FF);
	} else {
		push @charpoints, $smilly, 0;
	}
	return @charpoints;
}

sub characterizeish2 {
	my $smilly = shift;
	my $highSurrogate = floor(($smilly - 0x10000) / 0x400) + 0xD800;
	my $lowSurrogate = ($smilly - 0x10000) % 0x400 + 0xDC00;
	return ($highSurrogate, $lowSurrogate);
}
